#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <GL/glut.h>

#include "vector.h"
#include "Block.h"
#include "Canon.h"

struct _Canon {
  int count;

  double rotate_angle;
  double rotate_v;

  vector_t position;
  vector_t v;
  double angle;

  Block block;
};

Canon Canon_Create(Block block)
{
  Canon canon;

  canon = malloc(sizeof(*canon));
  memset(canon, 0, sizeof(*canon));

  canon->count = 50;

  canon->rotate_angle = 0.0;
  canon->rotate_v = (rand() % 91) - 45;

  vector_set(&canon->v, -((rand() % 25) + 5) * 0.01, 0.0, 0.0);
  vector_mul(&canon->position, &canon->v, -canon->count);

  canon->angle = -(rand() % 31);

  canon->block = block;

  return canon;
}

Canon Canon_Destroy(Canon canon)
{
  if (canon) free(canon);
  return NULL;
}

int Canon_Proc(Canon canon)
{
  if (canon->count == 0) {
    return 0;
  }
  canon->count--;
  canon->rotate_angle += canon->rotate_v;
  vector_add(&canon->position, &canon->position, &canon->v);
  return 1;
}

int Canon_MakePolygon(Canon canon)
{
  GLfloat color[] = { 0.0, 0.7, 0.7, 0.6 };

  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT , color);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE , color);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, color);

  glRotated(canon->angle, 0.0, 1.0, 0.0);

  glTranslated(canon->position.x, canon->position.y, canon->position.z);
  glRotated(canon->rotate_angle, 0.0, 0.0, 1.0);
  glScaled(0.1, 0.1, 0.1);

  glBegin(GL_POLYGON);
  glNormal3d( 0.0, 0.0, 1.0);
  glVertex3d( 1.0, 1.0, 0.0);
  glVertex3d(-1.0, 1.0, 0.0);
  glVertex3d(-1.0,-1.0, 0.0);
  glVertex3d( 1.0,-1.0, 0.0);
  glEnd();

  return 0;
}
