#ifndef _SAUCER_SAUCER_H_INCLUDED_
#define _SAUCER_SAUCER_H_INCLUDED_

typedef struct _Saucer *Saucer;

#include "Block.h"

Saucer Saucer_Create(double x, double y, double z,
		     int track_num, int sector_num, char *name);
int Saucer_Proc(Saucer saucer);
int Saucer_MakePolygon(Saucer saucer);
Block Saucer_GetBlock(Saucer saucer, int track, int sector);
vector_t *Saucer_GetPosition(Saucer saucer);
vector_t *Saucer_GetAngle(Saucer saucer);
int Saucer_GetTrackNum(Saucer saucer);
int Saucer_GetSectorNum(Saucer saucer);
int Saucer_AddTrackNum(Saucer saucer, int n);
int Saucer_AddSectorNum(Saucer saucer, int n);
int Saucer_SetName(Saucer saucer, char *name);
int Saucer_GetImageWidth(Saucer saucer);
int Saucer_GetImageHeight(Saucer saucer);
unsigned char *Saucer_GetImage(Saucer saucer);
int Saucer_SetScore(Saucer saucer, int score);
int Saucer_AddScore(Saucer saucer, int score);
int Saucer_GetScoreImageWidth(Saucer saucer);
int Saucer_GetScoreImageHeight(Saucer saucer);
unsigned char *Saucer_GetScoreImage(Saucer saucer);
unsigned char *Saucer_SetScoreImage(Saucer saucer);
int Saucer_Move(Saucer saucer, int count, double x, double y, double z);
int Saucer_Rotate(Saucer saucer, int count, double x, double y, double z);

#endif
